function [ compStruct ] = analyzeGraph( junctions, I, radius )


shortCut = 0;
compStruct = allStruct(junctions);
sizeCompStruct = size(compStruct);
for indexStruct = 1:sizeCompStruct(1)
   [startLines, endLines, junction] =  findLineBetween(junctions,compStruct{indexStruct});
   [startLines1, endLines1, listStruct1]  = recUntilStruct(startLines(1,:), endLines(1,:), junction, radius);
   [startLines2, endLines2, listStruct2]  = recUntilStruct(startLines(2,:), endLines(2,:), junction, radius);
   compStruct{indexStruct,2} = startLines1;
   compStruct{indexStruct,3} = endLines1;
   compStruct{indexStruct,4} = listStruct1;
   compStruct{indexStruct,5} = startLines2;
   compStruct{indexStruct,6} = endLines2;
   compStruct{indexStruct,7} = listStruct2;
   
   if (not(shortCut) && (cut(startLines1, endLines1, startLines2, endLines2)))
     
       
       [startLinesk, endLinesk, junctionk] =  findLineBetween(junctions,compStruct{indexStruct});
       [problemStart, problemEnd, listStruct1]  = recUntilStruct(startLines(1,:), endLines(1,:), junction, radius);
    
 
       problemStruct = compStruct{indexStruct, 1};
       shortCut = 1;
      
   end
   
end


if (shortCut)
  
   nameOfField  =  fieldnames(problemStruct);
   point        =problemStruct.(nameOfField{1});
   plotLines(problemStart, problemEnd, 'yellow');
   plotLines(startLinesk, endLinesk,'yellow');
   h2 = viscircles([point],1.4*radius);
   h1 = warndlg('Short circuit', 'Illegal circuit!!      ')
   
end
end

function [beginLines, endLines] = allWithoutStruct(beginLine, endLine)


sizeBegin = size(beginLine);
runner = 1;
for i = 1:sizeBegin(1)
    if not(isstruct(beginLine(i)) || isstruct(endLine(i)))
        beginLines(runner,:) = beginLine(i,:);
        endLines(runner,:) = endLine(i,:);
        runner = runner + 1;
    end
    
end
end

function [bool]  = equalRowsFlip(ls1, le1,ls2 ,le2, index1, index2)
    bool = (isequal(ls1(index1,:), ls2(index2,:)) && isequal(le1(index1,:), le2(index2,:))) ...
            || (isequal(le1(index1,:), ls2(index2,:)) && isequal(ls1(index1,:), le2(index2,:)))  ;
    return;
end

function [bool] = cut(ls1,le1, ls2,le2)
    bool = 0;
s1 = size(ls1);
s2 = size(ls2);
for i = 1:s1(1)

    for j = 1:s2(1);
        if (equalRowsFlip(ls1, le1, ls2, le2, i, j))
            bool = 1;
            return;
        end
    end
end
        
end

function [y] = printConnected(listS1, x, y, color)


sList = size(listS1);
for i = 1:sList(1)
    y = y +20;
    text( x ,y , fieldnames(listS1{i}),  'color', color, 'FontSize', 16);

end

y = y + 30;
end

function [index] = indexOfPoint(junctions, point, radius)
    index = -1;
    sizeOfJunctions = size(junctions);
    
    for i = 1:sizeOfJunctions(1)
       
        if isstruct(junctions{i})

            value = junctions{i};
            nameOfField  =  fieldnames(value);
            point2        =value.(nameOfField{1});
           
           if (pdist([point2;point],'euclidean') <= radius)

                index = i;
                return;
           end
           
           continue;
        end
        
        if (pdist([junctions{i};point],'euclidean') <= 10)

                index = i;
                return;
        end
    end

end


function [structList] = allStruct(junctions)
  sizeOfJunctions = size(junctions);
    structIndex = 1;

    for i = 1:sizeOfJunctions(1)
       if isstruct(junctions{i})
           structList{structIndex,1} = junctions{i};
           structIndex = structIndex + 1;
       end
    end

end

function [startLines, endLines, structList] = recUntilStruct(startLines, endLines, junctions, radius)
structList = [];
sLines = size(endLines);
 tempStart = [];
 
    for i = 1:sLines(1)
      
        indexOfJunction = indexOfPoint(junctions, endLines(i,:), radius);
                if (indexOfJunction == -1)
                     continue;
                end

        junction = junctions{indexOfJunction};
   
        if (not(isstruct(junction)))
            

            [tempStart, tempEnd, junctions] = linesFromDifferentJunction(junctions,indexOfJunction);
            [s, e, sL] = recUntilStruct(tempStart,tempEnd, junctions, radius);
 
           startLines =  cat(1,startLines,s);
           endLines =  cat(1, endLines,e);
            structList =  cat(1, structList ,sL);
          
         
        else
           structList = cat(1,{junction}, structList); 
        end

    end

end


function [startLines, endLines, newJunctions]= findLineBetween(junctions, struct )

rows = size(junctions);

    for rowRunner = 1:rows(1)
        
        value = junctions{rowRunner};
        if (isequal(junctions{rowRunner}, struct))
   
                  [startLines, endLines] = linesFromJunction(junctions, rowRunner);
                    newJunctions = removeStruct(junctions, value);
        end

    end

end
function [newJunctions] = removeStruct(junctions, struct)
    
sizeJunctions = size(junctions);
for rows = 1:sizeJunctions(1)
    col = 2;
   newJunctions{rows, 1} = junctions {rows, 1};
    for cols = 2:sizeOfRow(junctions, rows)
       
      if (isequal(struct, junctions{rows, cols}))
          continue;
      end
      
      
           newJunctions{rows, col} = junctions{rows, cols};
           col = col + 1;
        
        
    end
    
end

end

function [point] = pointFromJunction(junction)
 if (isstruct(junction))
           nameOfField =  fieldnames(junction);
           point =        junction.(nameOfField{1});
 else
    
        point = junction;
 end
 
end

%get all lines from junctions :) :)
function [startLines, endLines] = linesFromJunction(junctions, index)
   startLines = [];
   endLines = [];
    startPoint = pointFromJunction(junctions{index,1});
    numCols = sizeOfRow(junctions, index);
    for col = 2:numCols
       
        point = pointFromJunction(junctions{index, col});
        startLines = cat(1,startLines, startPoint);
        endLines = cat (1, endLines, point);
        
        
    end
   
end

%get all lines from junctions :) :)
function [startLines, endLines, junctions] = linesFromDifferentJunction(junctions, index)
   startLines = [];
   endLines = [];
    startPoint = pointFromJunction(junctions{index,1});
    numCols = sizeOfRow(junctions, index);
    for col = 2:numCols
    
        point = pointFromJunction(junctions{index, col});
 
       
        startLines = cat(1,startLines, startPoint);
        endLines = cat (1, endLines, point);
      
        
    end
   junctions = removeAllPoint(junctions, startPoint);
    
end


function [number] = sizeOfRow(list, index)
    sizeOfTable = size(list);
    if (index > sizeOfTable(1))
        number = 0;
        return;
    end
    for i =1:sizeOfTable(2)
        if (isempty(list{index,i}))
            number= i -1;
            return;
        end
    end
    number = sizeOfTable(2);
    
    
end

function [newJunctions] = removeAllPoint(junctions, point)



sizeJunctions = size(junctions);
for rows = 1:sizeJunctions(1)
    col = 2;
   newJunctions{rows, 1} = junctions {rows, 1};
    for cols = 2:sizeOfRow(junctions, rows)
       
       if (isstruct(junctions{rows, cols}))
           newJunctions{rows, col} = junctions{rows, cols};
           col = col + 1;
           continue;
       end;
       
        if  (pdist([junctions{rows, cols};point],'euclidean') > 3)
            
            newJunctions{rows, col} = junctions{rows, cols};
            col = col + 1;
        end
        
        
    end
    
end

end

function [] = plotLines(startPoint, endPoint, color)
    
     sizeOf = size(startPoint);
    for i = 1:sizeOf(1)
        
          xy = [startPoint(i,:);endPoint(i,:)];
          
       plot(xy(:,1),xy(:,2),'--','LineWidth',6,'Color',color);
    end
    
end


%get index of the component if Exists
function [index] = indexOfComponent(newJunction, struct)
index = -1;  
s = size(newJunction);
for i = 1:s(1)
    if isequal(newJunction{i},  struct)
        index = i;
        return;
    end
    
end

end


function [newJunctions] = sameValues(junctions)
s = size(junctions);
newJunctionIndex = 1;
newJunctions = [];
for i = 1:s(1)
     indexOfComponent = indexOfComponent(newJunctions,junctions{i});
     if (indexOfComponent == -1)
         newJunctions{newJunctionIndex, 1} = junctions{i};
         newJunctionIndex = newJunctionIndex + 1;
     else
            continue;
     end
end
        
end