I = imread('electric.jpg');
gray  =  rgb2gray(I);
level = graythresh(I);
BW = im2bw(I, level);
BW = not(BW);

%printing current Image
figure, imshow(I), title('Image got'), hold on

%finding for rotating!!
xy = findLargestLine(BW);

%get the angle to rotate
phi =pi -atan2((xy(1,2)-xy(2,2)),xy(1)-xy(2));
rotate = affine2d([ cos(phi)  sin(phi)  0; ...
            -sin(phi)  cos(phi)  0; ...
            0       0       1 ]);
      
 piVector   = [pi pi/2 -pi -pi/2];     
%rotateting.   

if (not(ismember(phi, piVector)))
    I = imwarp(I, rotate,'linear','FillValues',255);        
    figure, imshow(I), title('Image after rotated'), hold on
    BW = im2bw(I, level);
    BW = not(BW);
    figure, imshow(I), title('Image after rotated'), hold on
end

figure, imshow(BW), title('Image threshold'), hold on




[centers, radii] = imfindcircles(BW,[50 140]);

% h = viscircles(centers,radii);
% %x rec
% 
% for index = 1:length(radii) 
%     xRect  = centers(index,1) - radii(index);
%     yRect  = centers(index,2) - radii(index);
%     withRect = 2 * radii(index);
%     recCircle = [xRect,yRect,withRect,withRect];
%     recImage = imcrop(BW,recCircle);
%     imshow(recImage);   
% end

[Amper, Volt, Capac, Electric ] = segment(BW, I);
maxRadius = max(radii);
junctions = graphIt(BW, I, maxRadius, Amper, Volt, Capac, Electric);
%plot(coorV(1,1),coorV(1,2),'r.','MarkerSize',20)
interactivePlot(junctions, I, maxRadius);

