function [startLines,  endLines] = houghToGraph(BW, I)
    show = 0;

    [H,T,R] = hough(BW);
 
    xlabel('\theta'), ylabel('\rho');
    axis on, axis normal, hold on;
    P  = houghpeaks(H,800,'threshold',ceil(0.2*max(H(:))));
    x = T(P(:,2)); y = R(P(:,1)); 
    
    if (show == 1)
        plot(x,y,'s','color','white');
    end
        % Find lines and plot them
    lines = houghlines(BW,T,R,P,'FillGap',1,'MinLength',20);
    if (show == 1)
    figure, imshow(I), title('Finding All Lines with hough'), hold on
    end
    [startLines, endLines] = legal(lines);
    [startLines, endLines] = findIntersection(startLines, endLines);
    for k = 1:length(startLines)
     
        xy = [startLines(k,:);endLines(k,:)];
      if (show == 1)
       plot(xy(:,1),xy(:,2),'LineWidth',2,'Color','green');
       % Plot beginnings and ends of lines
       plot(xy(1,1),xy(1,2),'x','LineWidth',2,'Color','yellow');
       plot(xy(2,1),xy(2,2),'x','LineWidth',2,'Color','red');
      end
       % Determine the endpoints of the longest line segment
   
    end

    % highlight the longest line segment
 
end

function [bool] = intersectline(p1, p2, p)
bool = 0;
    if (abs(p1(2) - p(2)) < 8) && (abs(p2(2) - p(2)) < 8)
        if (p1(1) < p(1) && (p(1) < p2(1)))
            bool = 1;
        end
        if (p1(1) > p(1) && (p(1) > p2(1)))
              bool = 1;
        end
    else
        if (abs(p1(1) - p(1)) < 8 && (abs(p2(1) -  p(1))) < 8)
            if (p1(2) < p(2) && p(2) < p2(2))
                bool = 1;
            end
            if (p2(2) < p(2) && p(2) < p1(2))
                bool = 1;
            end
        end
    end
end

function [Start, End] = findIntersection(BeginLines, EndLines)
All = cat(1, BeginLines, EndLines);
willRemoveBegin = [];
willRemoveEnd = [];
Start = [];
End = [];


for i = 1:length(All)
   point = All(i,:); 
   
   for j = 1:length(BeginLines)
       if (intersectline(BeginLines(j,:), EndLines(j,:), point))
            if ( pdist([BeginLines(j,:);point],'euclidean') <= 8) ...
                    || ( pdist([EndLines(j,:);point],'euclidean') <= 8)
                  continue;
            end
    
           Start = cat(1,Start,BeginLines(j,:));
           End = cat(1,End,point);
           Start = cat(1,Start,point);
           End = cat(1,End,EndLines(j,:));
           willRemoveBegin = cat(1,willRemoveBegin, BeginLines(j,:));
           willRemoveEnd = cat(1,willRemoveEnd, EndLines(j,:));
           
       end
   end
   
end   

willRemoveBegin = unique(willRemoveBegin,'rows','stable');
willRemoveEnd = unique(willRemoveEnd,'rows', 'stable');

for j=1:length(BeginLines)
    if (notExistsTwoPoint(BeginLines(j,:), EndLines(j,:), willRemoveBegin, willRemoveEnd))
       Start =  cat(1, Start, BeginLines(j,:));
       End = cat(1, End, EndLines(j,:));
    end
end

end


function [bool] = notExistsTwoPoint(p1, p2, startL, endL)
bool =  1;
sL = size(startL);
for j = 1:sL(1)
    
    if ((p1(1) == startL(j,1)) && (p1(2) == startL(j,2)) ...
            && (p2(1) == endL(j,1)) && (p2(2) == endL(j,2)))
        bool = 0;
        return;
    end
end

end


function [realStart, realEnd] = legal(lines)
   startLine = [];
   endLine = [];
    for k = 1:length(lines)
        startLine = cat(1, startLine, lines(k).point1);
        endLine = cat(1, endLine, lines(k).point2);

    end
 realStart = startLine;
 realEnd = endLine;
% 
% for i = 1:length(startLine)
%      count = 0;
%     for j = 1:length(startLine)
%         
%         normValue = norm(endLine(i,:) - endLine(j,:));
%         
%         if (normValue ~= 0) && (normValue < 0)
%             count = count + 1;
%             
%         end
%             
%     end
%         if (count < 1)
%               realStart = cat(1, realStart, startLine(i,:));
%               realEnd = cat(1, realEnd,endLine(i,:));
%         end
%         
% end


end





function [] = plotLines(startPoint, endPoint)

 for k = 1:length(startPoint)
     
        xy = [startPoint(k,:);endPoint(k,:)];
       plot(xy(:,1),xy(:,2),'LineWidth',2,'Color','green');

       % Plot beginnings and ends of lines
       plot(xy(1,1),xy(1,2),'x','LineWidth',2,'Color','yellow');
       plot(xy(2,1),xy(2,2),'x','LineWidth',2,'Color','red');

       % Determine the endpoints of the longest line segment
   
 end
    
end