function varargout = layout(varargin)
% LAYOUT MATLAB code for layout.fig
%      LAYOUT, by itself, creates a new LAYOUT or raises the existing
%      singleton*.
%
%      H = LAYOUT returns the handle to a new LAYOUT or the handle to
%      the existing singleton*.
%
%      LAYOUT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LAYOUT.M with the given input arguments.
%
%      LAYOUT('Property','Value',...) creates a new LAYOUT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before layout_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to layout_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help layout

% Last Modified by GUIDE v2.5 18-Mar-2015 18:54:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @layout_OpeningFcn, ...
                   'gui_OutputFcn',  @layout_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before layout is made visible.
function layout_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to layout (see VARARGIN)

% Choose default command line output for layout
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes layout wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = layout_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in load.
function load_Callback(hObject, eventdata, handles)
% hObject    handle to load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
refresh
[filename, path] = uigetfile('*.jpg', 'Select electric cuircuit');
I = imread(fullfile(path,filename));
set(handles.Interactive,'Enable','off') 
handles.I = I;


subplot('position',[0.01, 0.01, 0.8, 1])
%imshow(I)
imshow(I,'InitialMagnification','fit');
set(handles.Analyze,'Enable','on') 
guidata(hObject, handles);

% --- Executes on button press in Analyze.
function Analyze_Callback(hObject, eventdata, handles)
% hObject    handle to Analyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
refresh

I = handles.I;

gray  =  rgb2gray(I);
level = graythresh(I);
BW = im2bw(I, level);
BW = not(BW);

%finding for rotating!!
xy = findLargestLine(BW);
h = waitbar(0,'Initializing Analyze...');


%get the angle to rotate
phi =pi -atan2((xy(1,2)-xy(2,2)),xy(1)-xy(2));
rotate = affine2d([ cos(phi)  sin(phi)  0; ...
            -sin(phi)  cos(phi)  0; ...
            0       0       1 ]);
      
 piVector   = [pi pi/2 3*pi/2 -3*pi/2 -pi 0 -pi/2];     
%rotateting.   

if (not(ismember(phi, piVector)))
    waitbar(0.10,h,'Rotating...');
    I = imwarp(I, rotate,'linear','FillValues',255);        
    BW = im2bw(I, level);
    BW = not(BW);
end

 waitbar(0.20,h,'Segmenting');
%subplot('position',[0.01, 0.01, 0.8, 1])

 %set(handles.Info,'string','Segmenting...');
 
 
[centers, radii] = imfindcircles(BW,[50 140]);

[Amper, Volt, Capac, Electric, Resistor, maxIndex ] = segment(BW, I, h);
% set(handles.Info,'Visible','On')
if (isempty(radii))
    maxRadius = 5 * maxIndex;
else
    maxRadius = max(radii);
end
   %set(handles.Info,'string','Graphing...');

junctions = graphIt(BW, I, maxRadius, Amper, Volt, Capac, Electric, Resistor, h);
%plot(coorV(1,1),coorV(1,2),'r.','MarkerSize',20)

%imshow(I,'InitialMagnification','fit');
handles.I = I;
handles.radius = maxRadius;
[compStructs] = analyzeGraph(junctions, I, maxRadius);
handles.compStructs = compStructs;

set(handles.Interactive,'Enable','on') 
guidata(hObject, handles);


% --- Executes on button press in Interactive.
function Interactive_Callback(hObject, eventdata, handles)

% hObject    handle to Interactive (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
refresh
c = findall(findobj(gcf),'Type','text');
delete(c);
interactiveIt(handles.I, handles.compStructs , handles.radius);
